Debian Bug report logs - #570723
libtool should set -e

Package: libtool; Maintainer for libtool is Kurt Roeckx <kurt@roeckx.be>; Source for libtool is src:libtool.

Reported by: Niko Tyni <ntyni@debian.org>

Date: Sat, 20 Feb 2010 21:36:01 UTC

Severity: wishlist

Tags: upstream

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Luis Rodrigo Gallardo Cruz <rodrigo@debian.org>:
Bug#570723; Package rep-gtk. (Sat, 20 Feb 2010 21:36:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
New Bug report received and forwarded. Copy sent to Luis Rodrigo Gallardo Cruz <rodrigo@debian.org>. (Sat, 20 Feb 2010 21:36:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: submit@bugs.debian.org
Subject: rep-gtk: broken on kfreebsd-amd64 by librep-dev #570719
Date: Sat, 20 Feb 2010 23:33:05 +0200
Package: rep-gtk
Version: 1:0.90.0-2
Severity: grave
Justification: renders package unusable

The package doesn't build properly on kfreebsd-amd64 due to #570719
in librep-dev causing libtool errors [1] and generating empty results.

-rw-r--r-- root/root         8 2009-11-20 06:30 ./usr/lib/rep/x86_64-pc-kfreebsd-gnu/gui/gtk-2/types.a
-rw-r--r-- root/root       988 2009-11-20 06:30 ./usr/lib/rep/x86_64-pc-kfreebsd-gnu/gui/gtk-2/types.la
-rw-r--r-- root/root      3688 2009-11-20 06:30 ./usr/lib/rep/x86_64-pc-kfreebsd-gnu/gui/gtk-2/types.so
-rw-r--r-- root/root         8 2009-11-20 06:30 ./usr/lib/rep/x86_64-pc-kfreebsd-gnu/gui/gtk-2/gtk.a
-rw-r--r-- root/root      1339 2009-11-20 06:30 ./usr/lib/rep/x86_64-pc-kfreebsd-gnu/gui/gtk-2/gtk.la
-rw-r--r-- root/root      4168 2009-11-20 06:30 ./usr/lib/rep/x86_64-pc-kfreebsd-gnu/gui/gtk-2/gtk.so

Trying to use the library fails with

$ rep /usr/share/doc/rep-gtk/examples/text.jl 
*** Error: No such structure, gui.gtk-2.gtk

Even though the primary bug is in librep-dev, I'm filing this because the
result is RC for rep-gtk. Please make rep-gtk detect this failure mode
in the future and abort the build instead of producing unusable packages.

[1] from https://buildd.debian.org/fetch.cgi?pkg=rep-gtk;ver=1%3A0.90.0-2;arch=kfreebsd-amd64;stamp=1258691519 

 /usr/lib/rep/x86_64-pc-kfreebsd-gnu/libtool --tag CC --mode=link --tag=CC x86_64-kfreebsd-gnu-gcc -avoid-version -module      -rpath /usr/lib/rep/x86_64-pc-kfreebsd-gnu  -DHAVE_CONFIG_H -I. -Wall -g -O2  -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include   -D_REENTRANT -I/usr/include/gtk-2.0 -I/usr/lib/gtk-2.0/include -I/usr/include/atk-1.0 -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/pixman-1 -I/usr/include/freetype2 -I/usr/include/directfb -I/usr/include/libpng12 -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include   -I/usr/include/ -I/usr/lib/rep/x86_64-pc-kfreebsd-gnu/   -I/usr/include/gtk-2.0 -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include   -o gtk-2/types.la rep-types.lo  -lglib-2.0   
 eval: 1: libtool_args+=: not found
 eval: 1: libtool_args+=: not found
 [...]

-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Luis Rodrigo Gallardo Cruz <rodrigo@debian.org>:
Bug#570723; Package rep-gtk. (Wed, 17 Mar 2010 07:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nobuhiro Iwamatsu <iwamatsu@debian.org>:
Extra info received and forwarded to list. Copy sent to Luis Rodrigo Gallardo Cruz <rodrigo@debian.org>. (Wed, 17 Mar 2010 07:39:03 GMT) Full text and rfc822 format available.

Message #10 received at 570723@bugs.debian.org (full text, mbox):

From: Nobuhiro Iwamatsu <iwamatsu@debian.org>
To: 570723@bugs.debian.org
Subject: Re: rep-gtk: broken on kfreebsd-amd64 by librep-dev #570719
Date: Wed, 17 Mar 2010 16:30:59 +0900
Hi,

It is the problem that happened because /bin/sh became dash as for this.
This problem will be fix by binNMU.

Best regards,
  Nobuhiro

-- 
Nobuhiro Iwamatsu
   iwamatsu at {nigauri.org / debian.org}
   GPG ID: 40AD1FA6




Bug reassigned from package 'rep-gtk' to 'libtool'. Request was from Tim Retout <diocles@debian.org> to control@bugs.debian.org. (Thu, 14 Oct 2010 07:39:15 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions rep-gtk/1:0.90.0-2. Request was from Tim Retout <diocles@debian.org> to control@bugs.debian.org. (Thu, 14 Oct 2010 07:39:16 GMT) Full text and rfc822 format available.

Severity set to 'wishlist' from 'grave' Request was from Tim Retout <diocles@debian.org> to control@bugs.debian.org. (Thu, 14 Oct 2010 07:39:16 GMT) Full text and rfc822 format available.

Changed Bug title to 'libtool should set -e' from 'rep-gtk: broken on kfreebsd-amd64 by librep-dev #570719' Request was from Tim Retout <diocles@debian.org> to control@bugs.debian.org. (Thu, 14 Oct 2010 07:39:17 GMT) Full text and rfc822 format available.

Added indication that 570723 affects rep-gtk Request was from Tim Retout <diocles@debian.org> to control@bugs.debian.org. (Thu, 14 Oct 2010 07:39:17 GMT) Full text and rfc822 format available.

Message sent on to Niko Tyni <ntyni@debian.org>:
Bug#570723. (Thu, 14 Oct 2010 07:39:22 GMT) Full text and rfc822 format available.

Message #23 received at 570723-submitter@bugs.debian.org (full text, mbox):

From: Tim Retout <diocles@debian.org>
To: 570723-submitter@bugs.debian.org
Cc: 570719@bugs.debian.org
Subject: rep-gtk and librep-dev bash/dash libtool breakage
Date: Thu, 14 Oct 2010 08:36:07 +0100
[Message part 1 (text/plain, inline)]
severity 570719 serious
reassign 570723 libtool
severity 570723 wishlist
retitle 570723 libtool should set -e
affects 570723 rep-gtk
thanks

I have looked at why rep-gtk's build system did not fail when #570719
occurred; it can happen on plain amd64 as well.  The problem is that
libtool did not exit with an error code, so there is really nothing
rep-gtk could have done.

I almost just closed #570723 - but I'll reassign to libtool, because
maybe it should 'set -e' or something (unless that's not portable).

To compensate for the downgrade, I guess #570719 must now be considered
serious.  I think it should have been from the start, really.

So we need a new librep-dev upload, and maybe a binNMU for rep-gtk on
some architectures.

-- 
Tim Retout <diocles@debian.org>
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Kurt Roeckx <kurt@roeckx.be>:
Bug#570723; Package libtool. (Thu, 14 Oct 2010 08:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ralf Wildenhues <Ralf.Wildenhues@gmx.de>:
Extra info received and forwarded to list. Copy sent to Kurt Roeckx <kurt@roeckx.be>. (Thu, 14 Oct 2010 08:21:04 GMT) Full text and rfc822 format available.

Message #28 received at 570723@bugs.debian.org (full text, mbox):

From: Ralf Wildenhues <Ralf.Wildenhues@gmx.de>
To: Tim Retout <diocles@debian.org>
Cc: 570723@bugs.debian.org, 570719@bugs.debian.org
Subject: Re: rep-gtk and librep-dev bash/dash libtool breakage
Date: Thu, 14 Oct 2010 10:11:42 +0200
* Tim Retout wrote on Thu, Oct 14, 2010 at 09:36:07AM CEST:
> I almost just closed #570723 - but I'll reassign to libtool, because
> maybe it should 'set -e' or something (unless that's not portable).

Issues such as this:

| eval: 1: libtool_args+=: not found
| eval: 1: libtool_args+=: not found

typically come from configure running the tests under a different shell
than libtool.  This is often because the configure.ac messes with $SHELL
and/or $CONFIG_SHELL, or CONFIG_SHELL is set in the environment.

The build log referenced looks like it ran under bash:

| checking whether the shell understands some XSI constructs... yes
| checking whether the shell understands "+="... yes

yet make uses /usr/lib/rep/x86_64-pc-kfreebsd-gnu/libtool which doesn't
seem to have been created by configure.  I suspect that
/usr/lib/rep/x86_64-pc-kfreebsd-gnu/libtool assumes /bin/sh is bash,
because at the time and on the system it was created it was bash.

In all likelihood, this is not a Libtool bug.

Cheers,
Ralf




Information forwarded to debian-bugs-dist@lists.debian.org, Kurt Roeckx <kurt@roeckx.be>:
Bug#570723; Package libtool. (Thu, 14 Oct 2010 08:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <diocles@debian.org>:
Extra info received and forwarded to list. Copy sent to Kurt Roeckx <kurt@roeckx.be>. (Thu, 14 Oct 2010 08:27:06 GMT) Full text and rfc822 format available.

Message #33 received at 570723@bugs.debian.org (full text, mbox):

From: Tim Retout <diocles@debian.org>
To: Ralf Wildenhues <Ralf.Wildenhues@gmx.de>
Cc: 570723@bugs.debian.org
Subject: Re: rep-gtk and librep-dev bash/dash libtool breakage
Date: Thu, 14 Oct 2010 09:26:00 +0100
 2010 09:11, Ralf Wildenhues <Ralf.Wildenhues@gmx.de> wrote:
> * Tim Retout wrote on Thu, Oct 14, 2010 at 09:36:07AM CEST:
>> I almost just closed #570723 - but I'll reassign to libtool, because
>> maybe it should 'set -e' or something (unless that's not portable).
>
> Issues such as this:
>
> | eval: 1: libtool_args+=: not found
> | eval: 1: libtool_args+=: not found
>
> typically come from configure running the tests under a different shell
> than libtool.  This is often because the configure.ac messes with $SHELL
> and/or $CONFIG_SHELL, or CONFIG_SHELL is set in the environment.
>
> The build log referenced looks like it ran under bash:
>
> | checking whether the shell understands some XSI constructs... yes
> | checking whether the shell understands "+="... yes
>
> yet make uses /usr/lib/rep/x86_64-pc-kfreebsd-gnu/libtool which doesn't
> seem to have been created by configure.  I suspect that
> /usr/lib/rep/x86_64-pc-kfreebsd-gnu/libtool assumes /bin/sh is bash,
> because at the time and on the system it was created it was bash.
>
> In all likelihood, this is not a Libtool bug.

Yep, this specific problem is with librep-dev not setting CONFIG_SHELL
explicitly, and I'll fix that in #570719.  But the bug I wanted to
raise was that this general class of errors - running the libtool
script with the wrong shell - does not cause a bad error code.  If
'set -e' were added at the top of libtool, it would fail early. Feel
free to 'wontfix' if that's not possible to do.

-- 
Tim Retout <diocles@debian.org>




Information forwarded to debian-bugs-dist@lists.debian.org, Kurt Roeckx <kurt@roeckx.be>:
Bug#570723; Package libtool. (Thu, 14 Oct 2010 18:30:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ralf Wildenhues <Ralf.Wildenhues@gmx.de>:
Extra info received and forwarded to list. Copy sent to Kurt Roeckx <kurt@roeckx.be>. (Thu, 14 Oct 2010 18:30:09 GMT) Full text and rfc822 format available.

Message #38 received at 570723@bugs.debian.org (full text, mbox):

From: Ralf Wildenhues <Ralf.Wildenhues@gmx.de>
To: Tim Retout <diocles@debian.org>, bug-libtool@gnu.org
Cc: 570723@bugs.debian.org
Subject: Re: rep-gtk and librep-dev bash/dash libtool breakage
Date: Thu, 14 Oct 2010 20:28:39 +0200
tags 570723 + upstream
thanks

[ http://bugs.debian.org/570723 ]

* Tim Retout wrote on Thu, Oct 14, 2010 at 10:26:00AM CEST:
>  2010 09:11, Ralf Wildenhues <Ralf.Wildenhues@gmx.de> wrote:
> > | eval: 1: libtool_args+=: not found
> > | eval: 1: libtool_args+=: not found
[...]
> > In all likelihood, this is not a Libtool bug.
> 
> Yep, this specific problem is with librep-dev not setting CONFIG_SHELL
> explicitly, and I'll fix that in #570719.  But the bug I wanted to
> raise was that this general class of errors - running the libtool
> script with the wrong shell - does not cause a bad error code.

Good point.  Tagging this bug as upstream one.  Sorry for misreading
your bug report at first.

> If 'set -e' were added at the top of libtool, it would fail early.

Indeed.  However, libtool is currently not 'set -e' clean, in the sense
that several code pieces expect to continue if some unchecked code fails
(either they are meant to ignore failure, or $? is checked afterwards).
Examples include func_show_eval in general.m4sh, basically all code
pieces in ltmain.m4sh that reference $?, and probably some system-
specific code snippets in libtool.m4.

I'm sure improving things on this front would help as cleanup, but there
are several portability warts that other shells have with 'set -e' code
(esp. with loop constructs) that outright enabling it doesn't seem
helpful to me except for bug hunting.

> Feel free to 'wontfix' if that's not possible to do.

Well, it is certainly possible to guard against this specific bug, esp.
since it is still a fairly common one to happen, let's keep it open for
now.

Thanks,
Ralf




Added tag(s) upstream. Request was from Ralf Wildenhues <Ralf.Wildenhues@gmx.de> to control@bugs.debian.org. (Thu, 14 Oct 2010 18:30:13 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 05:06:43 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.